> For the complete documentation index, see [llms.txt](https://docs.renfter.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.renfter.com/developers/integration/sdks/javascript-sdk.md).

# JavaScript SDK

Welcome to the Renfter Protocol JavaScript SDK. To begin, we recommend looking at the examples below, for deeper reference see the **JavaScript SDK Github** repo.

### Installation

```
npm i @renfter/js-sdk
// or
yarn add @renfter/js-sdk
```

### Usage

First you have to import Renfter and pass the ethers Signer.

```javascript
import { Renfter } from "@renfter/js-sdk";

const renfter = new Renfter({
    signer,
    [originContractAddress]
});
```

### Offer for NFT for lending

```javascript
renfter.offerForRent({
    tokenId,
    [tokenContractAddress],
    rentingPrice,
    maxRentDuration,
    [whitelistedFunctionality[]]
});
```

### Rent NFT

```javascript
renfter.rent({
    tokenId,
    duration
});
```

### Get lender (original owner)

```javascript
renter.getLender({
    tokenId,
    [tokenContractAddress]
});
```

### Get lender (original owner) by wrapped token ID

```javascript
renter.getLender({
    tokenId,
    [tokenContractAddress]
});
```

### Get borrower

<pre class="language-javascript"><code class="lang-javascript">renter.getBorrower({
    tokenId,
    [tokenContractAddress]
<strong>});
</strong></code></pre>

### Get borrower by wrapped data

```javascript
renter.getBorrowerByWrappedData({
    wTokenId,
    [wContractAddress],
});
```

### Get original contract address

```javascript
renter.getOriginalContractAddress(wContractAddress);
```

### Get wrapped contract address

```javascript
renter.getWrappedContractAddress(contractAddress);
```

### Get original token data

```javascript
renter.getOriginalTokenData({
    tokenId,
    [wContractAddress]
});
```

### Get token whitelisted methods

```javascript
renter.getWhitelistedMethodForTokenId(tokenId);
```

### Check if method is whitelisted

```javascript
renter.checkMethodForTokenId({
    tokenId,
    functionSignature
});
```

### Set token whitelisted methods

```javascript
renter.setWhitelistedMethodForTokenId({
    tokenId,
    functonSignature[],
    whitelisted[]
});
```

### Execute token's functionality

```javascript
renter.executeCustomFunctionality({
    tokenId,
    functionSignature,
    {functionArguments}
});
```

### Get all tokens for address

```javascript
renter.getTokens(address);
```

### Get all tokens available for renting for address

```javascript
renter.getAvailableTokens(address);
```

### Get all rented tokens tokens for address

```javascript
renter.getRentedTokens(address);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.renfter.com/developers/integration/sdks/javascript-sdk.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
